import 'package:flutter/material.dart';
import 'package:hub/shared/widgets.dart';

/// [ComponentWidget]

abstract class ComponentWidget<T> extends Widget {
  const ComponentWidget({super.key});
}

abstract class ModelComponent<T> extends ModelWidget
    implements ComponentWidget<T> {
  const ModelComponent({super.key});
}

abstract class StatelessComponent<T> extends StatelessWidget
    implements ComponentWidget<T> {
  const StatelessComponent({super.key});
}

abstract class StatefulComponent<T> extends StatefulWidget
    implements ComponentWidget<T> {
  const StatefulComponent({super.key});
}

abstract class ComponentState<T extends StatefulComponent> extends State<T> {}
